#include "Navigation/libraries/client/Navigator.h"

#include "ArmarXCore/core/exceptions/local/ExpressionException.h"

armarx::nav::client::Navigator::Navigator(core::NavigatorInterface& navigator) :
    navigator{&navigator}
{
    // pass
}

void
armarx::nav::client::Navigator::moveTo(const core::Pose& pose, core::NavigationFrame frame)
{
    moveTo(std::vector<core::Pose>{pose}, frame);
}

void
armarx::nav::client::Navigator::moveTo(const std::vector<core::Pose>& waypoints,
                                       core::NavigationFrame frame)
{
    ARMARX_CHECK_NOT_NULL(navigator);
    navigator->moveTo(waypoints, frame);
}

void
armarx::nav::client::Navigator::moveTowards(const core::Direction& direction,
                                            core::NavigationFrame frame)
{
    ARMARX_CHECK_NOT_NULL(navigator);
    navigator->moveTowards(direction, frame);
}

void
armarx::nav::client::Navigator::pause()
{
    ARMARX_CHECK_NOT_NULL(navigator);
    navigator->pause();
}

void
armarx::nav::client::Navigator::resume()
{
    ARMARX_CHECK_NOT_NULL(navigator);
    navigator->resume();
}

void
armarx::nav::client::Navigator::stop()
{
    ARMARX_CHECK_NOT_NULL(navigator);
    navigator->stop();
}

void
armarx::nav::client::Navigator::onGoalReached(const std::function<void(void)>& callback)
{
}

void
armarx::nav::client::Navigator::onGoalNearlyReached(const std::function<void(void)>& callback)
{
}

void
armarx::nav::client::Navigator::onWaypointReached(const std::function<void(int)>& callback)
{
}

void
armarx::nav::client::Navigator::onWaypointNearlyReached(const std::function<void(int)>& callback)
{
}

// TODO: Remove after fixing waitForGoalReached
#include <chrono>
#include <thread>

auto
armarx::nav::client::Navigator::waitForGoalReached() -> GoalReachedWaitResult
{
    // TODO: Actually implement this.
    bool stopped = false;
    do
    {
        std::this_thread::sleep_for(std::chrono::milliseconds{10});
        stopped = navigator->isStopped();
    } while (not stopped);

    GoalReachedWaitResult r;
    r.status = Status::Success;
    return r;
}

auto
armarx::nav::client::Navigator::waitForGoalNearlyReached() -> GoalReachedWaitResult
{
    return {};
}

auto
armarx::nav::client::Navigator::waitForWaypointReached() -> WaypointReachedWaitResult
{
    return {};
}

auto
armarx::nav::client::Navigator::waitForWaypointNearlyReached() -> WaypointReachedWaitResult
{
    return {};
}
